searchNodes=[{"doc":"When use-ed in a module that also use-es Ecto.Repo, augments the following Ecto.Repo callbacks to provide user definable hooks following successful execution.Hooks to MyApp.EctoSchema.after_get/2:all/2get/3get!/3get_by/3get_by!/3one/2one!/2Hooks to MyApp.EctoSchema.after_delete/2:delete/2delete!/2Hooks to MyApp.EctoSchema.after_insert/2:insert/2insert!/2Hooks to MyApp.EctoSchema.after_update/2:update/2update!/2Hooks to MyApp.EctoSchema.after_insert/2 or to MyApp.Ecto.Schema.after_update/2:insert_or_update/2insert_or_update!/2Hooks to MyApp.EctoSchema.before_delete/1:delete/2delete!/2Hooks to MyApp.EctoSchema.before_insert/1:insert/2insert!/2Hooks to MyApp.EctoSchema.before_update/1:update/2update!/2Hooks to MyApp.EctoSchema.before_insert/1 or to MyApp.Ecto.Schema.before_update/1:insert_or_update/2insert_or_update!/2Please note that for all after_* hooks, the result of executing a MyApp.Repo.* callback is what ultimately gets returned from the hook, and thus you should aim to write logic that is transparent and does not break the expected semantics or behaviour of said callback.Any results wrapped within an {:ok, _} or {:error, _} are also returned re-wrapped as expected.Also, all after_* hooks are provided an EctoHooks.Delta struct as a second parameter, which in some cases can be helpful for intuiting the diff between the result before versus after running a repo operation. Please see the docs pertaining to EctoHooks.Delta for more information.For all before_* hooks, the result returned by hook is passed directly to the MyApp.Repo.* callback called and thus care must be made to be aware of any implicit changes to changesets prior to writing to the database.The hooking functionality provided by EctoHooks can be pretty useful for resolving virtual fields, but can also prove useful for centralising some logging or telemetry logic.All defined hooks are executed synchronously immediately before or after calling into your configured database. To prevent the potential for hooks to infinite loop before returning, by default, EctoHooks will not trigger more than once within a single Repo call. You can opt out of this via calling EctoHooks.enable_hooks/0 in any of your defined hooks.This infinite loop protection only currently works within a given process. Take care when a defined hook may spawn other processes which may trigger database updates which themselves result in hooks being called.Example usage:def MyApp.Repo do use Ecto.Repo, otp_app: :my_app, adapter: Ecto.Adapters.Postgres use EctoHooks end def MyApp.User do use Ecto.Changeset require Logger schema &quot;users&quot; do field :first_name, :string field :last_name, :string field :full_name, :string, virtual: true end def before_insert(changeset) do Logger.warning(&quot;updating a user...&quot;) changeset end def after_get(%__MODULE__{} = user, %EctoHooks.Delta{}) do %__MODULE__{user | full_name: user.first_name &lt;&gt; &quot; &quot; &lt;&gt; user.last_name} end end","ref":"EctoHooks.html","title":"EctoHooks","type":"module"},{"doc":"Disables EctoHooks from running for all future Repo operations in the current process.","ref":"EctoHooks.html#disable_hooks/0","title":"EctoHooks.disable_hooks/0","type":"function"},{"doc":"Enables EctoHooks from running for all future Repo operations in the current process.","ref":"EctoHooks.html#enable_hooks/0","title":"EctoHooks.enable_hooks/0","type":"function"},{"doc":"Returns a boolean indicating if EctoHooks are enabled in the current process.","ref":"EctoHooks.html#hooks_enabled?/0","title":"EctoHooks.hooks_enabled?/0","type":"function"},{"doc":"Struct which is given as the 2nd argument to any after_* hook defined by EctoHooks.Contains metadata about the hook such as the particular Repo call which resulted in the hook being triggered, which hook was triggered, the source changeset, queryable, or struct which was passed into said Repo call.This can be particularly helpful for conditionally disabling or enabling hooks on a subset of triggers -- i.e. only when certain fields have changed in a given schema.In future, it might be possible for users to mark annotate certain Repo operations to trigger hooks only for those annotated functions. This is the mechanism by which that would work.","ref":"EctoHooks.Delta.html","title":"EctoHooks.Delta","type":"module"},{"doc":"","ref":"EctoHooks.Delta.html#new!/3","title":"EctoHooks.Delta.new!/3","type":"function"},{"doc":"This module provides an alternate interface for initializing EctoHooks.Ordinarily, one would need to add the use EctoHooks statement to an Ecto.Repo implementation module in one's application.This module instead simply replaces the use Ecto.Repo, ... statement with the following:defmodule MyApp.Repo do use EctoHooks.Repo, otp_app: :my_app, ... endAny paramters passed into use EctoHooks.Repo are simply forwarded to Ecto.Repo and EctoHooks functionality is automatically included.See the documentation to EctoHooks for more information.","ref":"EctoHooks.Repo.html","title":"EctoHooks.Repo","type":"module"}]